//
// Library: Net Responsibility
// Package: Core
// Module:  Request
//
// This file is part of Net Responsibility.
//
// Net Responsibility is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// Net Responsibility is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Net Responsibility.  If not, see <http://www.gnu.org/licenses/>.
//
// <Request> is in charge of interaction with the server



#ifndef REQUEST_H
#define REQUEST_H

#include <iostream>
#include <fstream>
#include <sstream>

#include "Options.h"
#include "Blacklist.h"

#include "Poco/Net/HTTPClientSession.h"
#include "Poco/Net/HTTPRequest.h"
#include "Poco/Net/HTTPResponse.h"
#include "Poco/Util/Application.h"
#include "Poco/Util/XMLConfiguration.h"
#include "Poco/Logger.h"
#include "Poco/StreamCopier.h"
#include "Poco/Timestamp.h"
#include "Poco/Path.h"
#include "Poco/File.h"
#include "Poco/URI.h"
#include "Poco/Exception.h"
#include "Poco/Thread.h"

using Poco::Net::HTTPClientSession;
using Poco::Net::HTTPRequest;
using Poco::Net::HTTPResponse;
using Poco::Net::HTTPMessage;
using Poco::Util::Application;
using Poco::Util::XMLConfiguration;
using Poco::Logger;
using Poco::StreamCopier;
using Poco::Timestamp;
using Poco::Path;
using Poco::File;
using Poco::URI;
using Poco::Exception;

using namespace std;

class Options; //Forward declaration

class Request
{
	public:
		Request() {}
		virtual ~Request() {}
		static void addMac(Options*, string = "");
		static void downloadConfig(Options*, string = "");
		static void downloadBlacklist(Options*);
		static string sendImprovementData(Options*, string);
		static bool modifiedFilesUpdate(Options*);

	private:
		static string send(Options*, string, string = "", string = "");
};

#endif // REQUEST_H
