//
// Library: Net Responsibility
// Package: Core
// Module:  Warnings
//
// This file is part of Net Responsibility.
//
// Net Responsibility is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// Net Responsibility is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Net Responsibility.  If not, see <http://www.gnu.org/licenses/>.
//
// <Warnings> is able to store all inappropriate URLs and useful additional info


#ifndef WARNINGS_H
#define WARNINGS_H

#include "History.h"
#include "Blacklist.h"

class Warnings: public History
{
	public:
		Warnings();
		virtual ~Warnings();
		void setRows(vector<HistoryRow, allocator<HistoryRow> > &rows,
				vector<BlacklistMatch, allocator<BlacklistMatch> > &matches);
		void addRow(HistoryRow, BlacklistMatch);
		int getStrength() const;
		int getStrength(int) const;
		int size() const;
		string getBoldUrl() const;
		string getBoldUrl(int) const;
		string getAbbrUrl() const;
		string getAbbrUrl(int) const;
		vector<BlacklistKeyword> getKeywords() const;
		vector<BlacklistKeyword> getKeywords(int) const;
	protected:
		vector<BlacklistMatch, allocator<BlacklistMatch> > _blacklistMatches;
};


#endif // WARNINGS_H
